/* Microsoft SQL Server - Scripting			*/
/* Server: MEGADETH			*/
/* Database: MHB			*/
/* Creation Date 3/16/96 7:17:57 AM 			*/
/****** Create new database device and database in specified SQL Server. ******/
/* Create Device for Database */
declare @retcode int,
	@vdevno int,
	@exec_str varchar(255),
	@size_in_blocks int,
	@logical varchar(30),
	@physical varchar(255),
	@size int

/* This can be modified for your system. */
select @logical = 'MHB'
/* This needs to be modified for your system. */
select @physical = 'c:\sql60\data\mhb.dat'
/* Maintain size to your preference */
select @size = 5

/* Get next available device number for this segment. */
select @vdevno = null
select @vdevno = (min(low)/0x01000000)+1
  from sysdevices d1
    where low/0x01000000 between 0 and 254
      and not exists
        (select * from sysdevices d2
          where d2.low/0x01000000 =
	    (d1.low/0x01000000)+1)

if @vdevno is null or @@error <> 0
  begin
    raiserror(15054,-1,-1)
  end

select @size_in_blocks = @size * 512.

disk init
  name = @logical,
  physname = @physical,
  size = @size_in_blocks,
  vdevno = @vdevno

GO

/* Create database */
USE MASTER
GO

/* Modify database size to your preference. */
CREATE DATABASE MHB ON MHB=5 
GO

/* Begin table creation */
USE MHB
GO
/****** Object:  Table dbo.tblDeveloperNotes    Script Date: 3/16/96 7:18:00 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tblDeveloperNotes') and sysstat & 0xf = 3)
	drop table dbo.tblDeveloperNotes
GO

CREATE TABLE tblDeveloperNotes
(
	NoteId smallint NOT NULL ,
	LevelId smallint NOT NULL ,
	ParentId smallint NULL ,
	Bullet varchar (255) NULL ,
	Heading varchar (255) NULL ,
	Graphic varchar (255) NULL ,
	Purpose text NULL ,
	Body text NULL ,
	ReturnPage varchar (255) NULL ,
	CONSTRAINT PK___1__11 PRIMARY KEY  CLUSTERED 
	(
		NoteId
	)
)
GO

/****** Object:  Table dbo.tlkpCategory    Script Date: 3/16/96 7:18:02 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tlkpCategory') and sysstat & 0xf = 3)
	drop table dbo.tlkpCategory
GO

CREATE TABLE tlkpCategory
(
	CategoryId char (2) NOT NULL ,
	Category varchar (25) NULL ,
	CONSTRAINT PK__tlkpCateg__Categ__103673A0 PRIMARY KEY  CLUSTERED 
	(
		CategoryId
	)
)
GO

/****** Object:  Table dbo.tlkpCountry    Script Date: 3/16/96 7:18:04 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tlkpCountry') and sysstat & 0xf = 3)
	drop table dbo.tlkpCountry
GO

CREATE TABLE tlkpCountry
(
	CountryId smallint NOT NULL ,
	Country varchar (25) NULL ,
	CONSTRAINT PK__tlkpCount__Count__07A12D9F PRIMARY KEY  CLUSTERED 
	(
		CountryId
	)
)
GO

/****** Object:  Table dbo.tlkpPaymentMethod    Script Date: 3/16/96 7:18:05 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tlkpPaymentMethod') and sysstat & 0xf = 3)
	drop table dbo.tlkpPaymentMethod
GO

CREATE TABLE tlkpPaymentMethod
(
	PaymentId smallint NOT NULL ,
	PaymentMethod varchar (25) NULL ,
	CONSTRAINT PK__tlkpPayme__Payme__0D5A06F5 PRIMARY KEY  CLUSTERED 
	(
		PaymentId
	)
)
GO

/****** Object:  Table dbo.tlkpShippingMethod    Script Date: 3/16/96 7:18:07 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tlkpShippingMethod') and sysstat & 0xf = 3)
	drop table dbo.tlkpShippingMethod
GO

CREATE TABLE tlkpShippingMethod
(
	ShippingId smallint NOT NULL ,
	ShippingMethod varchar (25) NULL ,
	ShippingRate money NULL ,
	CONSTRAINT PK__tlkpShipp__Shipp__0A7D9A4A PRIMARY KEY  CLUSTERED 
	(
		ShippingId
	)
)
GO

/****** Object:  Table dbo.tlkpState    Script Date: 3/16/96 7:18:09 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tlkpState') and sysstat & 0xf = 3)
	drop table dbo.tlkpState
GO

CREATE TABLE tlkpState
(
	StateId char (2) NOT NULL ,
	State varchar (30) NULL ,
	CONSTRAINT PK__tlkpState__State__04C4C0F4 PRIMARY KEY  CLUSTERED 
	(
		StateId
	)
)
GO

/****** Object:  Table dbo.tlkpTitle    Script Date: 3/16/96 7:18:10 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tlkpTitle') and sysstat & 0xf = 3)
	drop table dbo.tlkpTitle
GO

CREATE TABLE tlkpTitle
(
	TitleId smallint NOT NULL ,
	Title varchar (25) NULL ,
	CONSTRAINT PK__tlkpTitle__Title__01E85449 PRIMARY KEY  CLUSTERED 
	(
		TitleId
	)
)
GO

/****** Object:  Table dbo.tblCustomer    Script Date: 3/16/96 7:18:12 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tblCustomer') and sysstat & 0xf = 3)
	drop table dbo.tblCustomer
GO

CREATE TABLE tblCustomer
(
	CustomerId int IDENTITY (1, 1) NOT NULL ,
	CustomerLastName varchar (25) NOT NULL ,
	CustomerFirstName varchar (25) NOT NULL ,
	CustomerEMail varchar (50) NOT NULL ,
	CustomerPassword varchar (25) NOT NULL ,
	CustomerTitle smallint NULL ,
	CustomerOrganization varchar (50) NULL ,
	CustomerAddress1 varchar (25) NULL ,
	CustomerAddress2 varchar (25) NULL ,
	CustomerAddress3 varchar (25) NULL ,
	CustomerCity varchar (40) NULL ,
	CustomerState char (2) NULL ,
	CustomerZip char (5) NULL ,
	CustomerCountry smallint NULL ,
	CustomerProvince varchar (20) NULL ,
	CustomerPostalCode varchar (20) NULL ,
	CustomerPhone char (10) NULL ,
	CustomerFax char (10) NULL ,
	CustomerURL varchar (50) NULL ,
	CONSTRAINT PK__tblCustom__Custo__16E3712F PRIMARY KEY  CLUSTERED 
	(
		CustomerId
	),
	CONSTRAINT FK__tblCustom__Custo__17D79568 FOREIGN KEY 
	(
		CustomerTitle
	) REFERENCES dbo.tlkpTitle (
		TitleId
	),
	CONSTRAINT FK__tblCustom__Custo__18CBB9A1 FOREIGN KEY 
	(
		CustomerState
	) REFERENCES dbo.tlkpState (
		StateId
	),
	CONSTRAINT FK__tblCustom__Custo__19BFDDDA FOREIGN KEY 
	(
		CustomerCountry
	) REFERENCES dbo.tlkpCountry (
		CountryId
	)
)
GO

 CREATE  INDEX CustomerCountry ON dbo.tblCustomer(CustomerCountry)
GO

 CREATE  UNIQUE  INDEX CustomerEMail ON dbo.tblCustomer(CustomerEMail)
GO

 CREATE  INDEX CustomerState ON dbo.tblCustomer(CustomerState)
GO

 CREATE  INDEX CustomerTitle ON dbo.tblCustomer(CustomerTitle)
GO

/****** Object:  Table dbo.tblOrder    Script Date: 3/16/96 7:18:14 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tblOrder') and sysstat & 0xf = 3)
	drop table dbo.tblOrder
GO

CREATE TABLE tblOrder
(
	OrderId int IDENTITY (1, 1) NOT NULL ,
	CustomerId int NOT NULL ,
	OrderDate datetime NULL ,
	OrderShipDate datetime NULL ,
	OrderShipMethod smallint NULL ,
	OrderShipToTitle smallint NULL ,
	OrderShipToLastName varchar (25) NULL ,
	OrderShipToFirstName varchar (25) NULL ,
	OrderShipToOrganization varchar (50) NULL ,
	OrderShipToAddress1 varchar (25) NULL ,
	OrderShipToAddress2 varchar (25) NULL ,
	OrderShipToAddress3 varchar (25) NULL ,
	OrderShipToCity varchar (40) NULL ,
	OrderShipToState char (2) NULL ,
	OrderShipToZip char (5) NULL ,
	OrderShipToCountry smallint NULL ,
	OrderShipToProvince varchar (20) NULL ,
	OrderShipToPostalCode varchar (20) NULL ,
	OrderShipToPhone char (10) NULL ,
	OrderPaymentMethod smallint NULL ,
	OrderPaymentCreditCard char (16) NULL ,
	OrderPaymentExpirationDate char (4) NULL ,
	OrderPaymentOther varchar (25) NULL ,
        OrderShippingCosts money NULL ,
	OrderPaymentAmount money NULL ,
	CONSTRAINT PK__tblOrder__OrderI__1C9C4A85 PRIMARY KEY  CLUSTERED 
	(
		OrderId
	),
	CONSTRAINT FK__tblOrder__OrderP__2160FFA2 FOREIGN KEY 
	(
		OrderPaymentMethod
	) REFERENCES dbo.tlkpPaymentMethod (
		PaymentId
	),
	CONSTRAINT FK__tblOrder__OrderS__1D906EBE FOREIGN KEY 
	(
		OrderShipMethod
	) REFERENCES dbo.tlkpShippingMethod (
		ShippingId
	),
	CONSTRAINT FK__tblOrder__OrderS__1E8492F7 FOREIGN KEY 
	(
		OrderShipToTitle
	) REFERENCES dbo.tlkpTitle (
		TitleId
	),
	CONSTRAINT FK__tblOrder__OrderS__1F78B730 FOREIGN KEY 
	(
		OrderShipToState
	) REFERENCES dbo.tlkpState (
		StateId
	),
	CONSTRAINT FK__tblOrder__OrderS__206CDB69 FOREIGN KEY 
	(
		OrderShipToCountry
	) REFERENCES dbo.tlkpCountry (
		CountryId
	)
)
GO

 CREATE  INDEX CustomerId ON dbo.tblOrder(CustomerId)
GO

 CREATE  INDEX OrderPaymentMethod ON dbo.tblOrder(OrderPaymentMethod)
GO

 CREATE  INDEX OrderShipMethod ON dbo.tblOrder(OrderShipMethod)
GO

 CREATE  INDEX OrderShipToCountry ON dbo.tblOrder(OrderShipToCountry)
GO

 CREATE  INDEX OrderShipToState ON dbo.tblOrder(OrderShipToState)
GO

 CREATE  INDEX OrderShipToTitle ON dbo.tblOrder(OrderShipToTitle)
GO

/****** Object:  Table dbo.tblProduct    Script Date: 3/16/96 7:18:16 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tblProduct') and sysstat & 0xf = 3)
	drop table dbo.tblProduct
GO

CREATE TABLE tblProduct
(
	ProductId char (7) NOT NULL ,
	ProductName varchar (25) NOT NULL ,
	ProductDescription varchar (255) NULL ,
	ProductCategory char (2) NULL ,
	ProductPrice money NULL ,
	UnitsInStock smallint NULL ,
	ProductWeight int NULL ,
	Image varchar (100) NULL ,
	Marquee varchar (100) NULL ,
	SmallMarquee varchar (100) NULL ,
	CONSTRAINT PK__tblProduc__Produ__1312E04B PRIMARY KEY  CLUSTERED 
	(
		ProductId
	),
	CONSTRAINT FK__tblProduc__Produ__14070484 FOREIGN KEY 
	(
		ProductCategory
	) REFERENCES dbo.tlkpCategory (
		CategoryId
	)
)
GO

 CREATE  INDEX ProductCategory ON dbo.tblProduct(ProductCategory)
GO

/****** Object:  Table dbo.tblOrderDetail    Script Date: 3/16/96 7:18:17 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tblOrderDetail') and sysstat & 0xf = 3)
	drop table dbo.tblOrderDetail
GO

CREATE TABLE tblOrderDetail
(
	DetailItemId int IDENTITY (1, 1) NOT NULL ,
	DetailOrderId int NOT NULL ,
	DetailProductId char (7) NOT NULL ,
	DetailQuantity int NULL ,
	DetailAmount money NULL ,
	DetailItemWeight real NULL ,
	DetailShipDate datetime NULL ,
	CONSTRAINT PK__tblOrderD__Detai__243D6C4D PRIMARY KEY  CLUSTERED 
	(
		DetailItemId
	),
	CONSTRAINT FK__tblOrderD__Detai__25319086 FOREIGN KEY 
	(
		DetailOrderId
	) REFERENCES dbo.tblOrder (
		OrderId
	),
	CONSTRAINT FK__tblOrderD__Detai__2625B4BF FOREIGN KEY 
	(
		DetailProductId
	) REFERENCES dbo.tblProduct (
		ProductId
	)
)
GO

 CREATE  INDEX DetailOrderId ON dbo.tblOrderDetail(DetailOrderId)
GO

 CREATE  INDEX DetailProductId ON dbo.tblOrderDetail(DetailProductId)
GO

/****** Object:  Table dbo.tblTempConsolidation    Script Date: 3/16/96 7:18:19 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tblTempConsolidation') and sysstat & 0xf = 3)
	drop table dbo.tblTempConsolidation
GO

CREATE TABLE tblTempConsolidation
(
	CustomerID int NOT NULL ,
	ProductID char (7) NOT NULL ,
	Quantity smallint NULL ,
	CONSTRAINT PK_tblTempConsolidation_1__10 PRIMARY KEY  CLUSTERED 
	(
		CustomerID,
		ProductID
	),
	CONSTRAINT FK__tblTempCo__Custo__2EBAFAC0 FOREIGN KEY 
	(
		CustomerID
	) REFERENCES dbo.tblCustomer (
		CustomerId
	),
	CONSTRAINT FK__tblTempCo__Produ__2FAF1EF9 FOREIGN KEY 
	(
		ProductID
	) REFERENCES dbo.tblProduct (
		ProductId
	)
)
GO

 CREATE  INDEX CustomerId ON dbo.tblTempConsolidation(CustomerID)
GO

 CREATE  INDEX ProductID ON dbo.tblTempConsolidation(ProductID)
GO

/****** Object:  Table dbo.tblTempOrders    Script Date: 3/16/96 7:18:21 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.tblTempOrders') and sysstat & 0xf = 3)
	drop table dbo.tblTempOrders
GO

CREATE TABLE tblTempOrders
(
	TempOrderID int IDENTITY (1, 1) NOT NULL ,
	CustomerID int NOT NULL ,
	ProductID char (7) NULL ,
	Quantity smallint NULL ,
	CONSTRAINT PK__tblTempOr__TempO__2902216A PRIMARY KEY  CLUSTERED 
	(
		TempOrderID
	),
	CONSTRAINT FK__tblTempOr__Custo__29F645A3 FOREIGN KEY 
	(
		CustomerID
	) REFERENCES dbo.tblCustomer (
		CustomerId
	),
	CONSTRAINT FK__tblTempOr__Produ__2AEA69DC FOREIGN KEY 
	(
		ProductID
	) REFERENCES dbo.tblProduct (
		ProductId
	)
)
GO

 CREATE  INDEX CustomerID ON dbo.tblTempOrders(CustomerID)
GO

 CREATE  INDEX ProductID ON dbo.tblTempOrders(ProductID)
GO

/****** Object:  View dbo.SubTotalWeightPrice    Script Date: 3/16/96 7:18:23 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.SubTotalWeightPrice') and sysstat & 0xf = 2)
	drop view dbo.SubTotalWeightPrice
GO

CREATE VIEW SubTotalWeightPrice AS
(
SELECT CustomerId, TotalWeight = SUM(tblProduct.ProductWeight * tblTempConsolidation.Quantity),
SubTotal = Convert(money, SUM(tblProduct.ProductPrice * tblTempConsolidation.Quantity))
FROM tblProduct, tblTempConsolidation
WHERE tblProduct.ProductId = tblTempConsolidation.ProductId
Group By CustomerId
)

GO

/****** Object:  View dbo.SummarizeLineItems    Script Date: 3/16/96 7:18:23 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.SummarizeLineItems') and sysstat & 0xf = 2)
	drop view dbo.SummarizeLineItems
GO

CREATE VIEW SummarizeLineItems AS
(
SELECT DISTINCT 
tblTempConsolidation.CustomerID, 
tblTempConsolidation.ProductID, 
tblTempConsolidation.Quantity, 
tblProduct.ProductName, 
tblProduct.ProductWeight, 
tblProduct.ProductPrice,
SubTotalWeight = Quantity * ProductWeight,
LineSub = Quantity * ProductPrice
FROM tblProduct, tblTempConsolidation
WHERE tblProduct.ProductId = tblTempConsolidation.ProductID
GROUP BY tblTempConsolidation.CustomerID, 
tblTempConsolidation.ProductID, 
tblTempConsolidation.Quantity, 
tblProduct.ProductName, 
tblProduct.ProductWeight, 
tblProduct.ProductPrice,
Quantity * ProductWeight, 
Quantity * ProductPrice
)

GO

